﻿using System;
using System.Collections.Generic;
using System.Text;

namespace SmarterNotify.Data.Providers
{
    public class Provider
    {
        public string ProviderGUID { get; set; }
        public string ProviderName { get; set; }
        public string ProviderURL { get; set; }
        public List<ProviderField> ProviderFields { get; set; }
        public bool Enabled { get; set; }

        public Provider()
        {
            ProviderGUID = Guid.NewGuid().ToString("N");
            ProviderName = string.Empty;
            ProviderURL = string.Empty;
            ProviderFields = new List<ProviderField>();
            Enabled = false;
        }
    }// class
}// namespace