﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SmarterNotify.Data.Voice
{
    public class VoiceEntry
    {
        public enum VoiceEntryType
        {
            ReplaceText,
            ReplaceRegex
        }
        public VoiceEntryType EntryType = VoiceEntryType.ReplaceText;
        public string Key { get; set; }
        public string Val { get; set; }

        public VoiceEntry()
        {
            EntryType = VoiceEntryType.ReplaceText;
            Key = string.Empty;
            Val = string.Empty;
        }
        public VoiceEntry(VoiceEntryType EntryType, string Key, string Val)
        {
            this.EntryType = EntryType;
            this.Key = Key;
            this.Val = Val;
        }
    }
}
