﻿using System;
using System.Collections.Generic;
using System.Text;
using SmarterNotify.Data.Events;
using SmarterNotify.HelperClasses;
using System.IO;
using System.Xml;

namespace SmarterNotify.DataHandlers
{
    // Not Implemented at this time...

    //// Class not being used currently...
    //public class ReminderEventHandler
    //{
    //    private static Dictionary<string, ReminderEvent> Events = new Dictionary<string, ReminderEvent>();
    //    private static object EventLocker = new object();

    //    public static void LoadEventsFromFile()
    //    {
    //        try
    //        {
    //            // open a connection to the events file and load all the available ones to memory
    //            LoadEventsFromFile(AppPath.EventsFilePath);
    //        }
    //        catch (Exception ex) 
    //        {
    //            string logMsg = "Error occurred while loading events from file";
    //            TrackingHelper.TrackError(TrackingHelper.RecordType.Both, "Error Occurred", logMsg, logMsg, ex);
    //        }
    //    }
    //    public static void LoadEventsFromFile(string fileLocation)
    //    {
    //        lock (EventLocker)
    //        {
    //            foreach (ReminderEvent rEvent in GetEventsFromFile(fileLocation))
    //                Events[rEvent.EventGUID] = rEvent;
    //        }
    //    }
    //    public static List<ReminderEvent> GetEventsFromFile(string fileLocation)
    //    {
    //        List<ReminderEvent> retVal = new List<ReminderEvent>();
    //        FileInfo info = new FileInfo(fileLocation);
    //        if (info.Extension.ToUpperInvariant().Contains("XML"))
    //        {
    //            try
    //            {
    //                if (!File.Exists(fileLocation))
    //                {
    //                    XmlTextWriter xmlWrite = new XmlTextWriter(fileLocation, null);
    //                    xmlWrite.WriteStartDocument();
    //                    xmlWrite.WriteStartElement("Events");
    //                    xmlWrite.WriteEndElement();
    //                    xmlWrite.Flush();
    //                    xmlWrite.Close();
    //                }

    //                XmlTextReader xmlRead = new XmlTextReader(fileLocation);

    //                while (xmlRead.Read())
    //                {
    //                    switch (xmlRead.NodeType)
    //                    {
    //                        case XmlNodeType.Element:
    //                            if (xmlRead.Name == "Event")
    //                            {
    //                                ReminderEvent rEvent = InterpretEvent(ref xmlRead);
    //                                if (rEvent != null)
    //                                    retVal.Add(rEvent);
    //                            }
    //                            break;
    //                    }
    //                }

    //                xmlRead.Close();
    //            }
    //            catch (Exception ex) 
    //            {
    //                string logMsg = "Error occurred while getting events from file";
    //                TrackingHelper.TrackError(TrackingHelper.RecordType.Both, "Error Occurred", logMsg, logMsg, ex);
    //            }
    //        }
    //        return retVal;
    //    }
    //    public static ReminderEvent InterpretEvent(ref XmlTextReader xmlRead)
    //    {
    //        ReminderEvent loadedEvent = new ReminderEvent();
    //        // initiate to the first node of this profile
    //        string eventGUID = xmlRead["guid"] == null ? "" : xmlRead["guid"];
    //        if (string.IsNullOrEmpty(eventGUID))
    //            return null;
    //        else
    //            loadedEvent.EventGUID = eventGUID;

    //        int intParse = -1;
    //        bool boolParse = false;
    //        xmlRead.Read();
    //        while (xmlRead.Name.ToUpperInvariant() != "EVENT" && xmlRead.NodeType != XmlNodeType.EndElement)
    //        {
    //            if (xmlRead.NodeType == XmlNodeType.Element)
    //            {
    //                switch (xmlRead.Name.ToUpperInvariant())
    //                {
    //                    case "EVENTNAME": loadedEvent.Name = xmlRead["value"]; break;
    //                    case "MESSAGE": loadedEvent.Message = xmlRead["value"]; break;
    //                    case "ENABLED": 
    //                        if (bool.TryParse(xmlRead["value"], out boolParse))
    //                            loadedEvent.Enabled = boolParse;
    //                        break;
    //                    case "MAXOCCURENCESPERHOUR": 
    //                        if (int.TryParse(xmlRead["value"], out intParse))
    //                            loadedEvent.MaxOccurencesPerHour = intParse;
    //                        break;
    //                    case "CONDITIONS":
    //                        while (xmlRead.Name.ToUpperInvariant() != "CONDITIONS" && xmlRead.NodeType != XmlNodeType.EndElement)
    //                        {
    //                            ReadCondition(ref xmlRead, ref loadedEvent);
    //                            if (xmlRead.EOF)
    //                                break;
    //                        }
    //                        break;
    //                }
    //            }
    //            xmlRead.Read();
    //        }

    //        return loadedEvent;
    //    }
    //    public static void ReadCondition(ref XmlTextReader xmlRead, ref ReminderEvent rEvent)
    //    {
    //        xmlRead.Read();
    //        while (xmlRead.Name.ToUpperInvariant() != "CONDITION" && xmlRead.NodeType != XmlNodeType.EndElement)
    //        {
    //            EventCondition condition = new EventCondition();
    //            if (xmlRead.NodeType == XmlNodeType.Element)
    //            {
    //                switch (xmlRead.Name.ToUpperInvariant())
    //                {
    //                    case "CONDITIONNAME": condition.Name = xmlRead["value"]; break;
    //                    case "ARGUMENT": 
    //                        string argType = xmlRead["value"];
    //                        switch (argType)
    //                        {
    //                            case "CONTAINS": condition.Argument = EventCondition.ArgumentType.Contains; break;
    //                            case "EQUALS": condition.Argument = EventCondition.ArgumentType.Equals; break;
    //                            case "GREATERTHAN": condition.Argument = EventCondition.ArgumentType.GreaterThan; break;
    //                            case "LESSTHAN": condition.Argument = EventCondition.ArgumentType.LessThan; break;
    //                        }
    //                        break;
    //                    case "CONDITIONTYPE": 
    //                        string conType = xmlRead["value"];
    //                        switch (conType)
    //                        {
    //                            case "PROFILEUNAUTHORIZED": condition.Condition = EventCondition.ConditionType.ProfileUnauthorized; break;
    //                            case "PROFILEUNAVAILABLE": condition.Condition = EventCondition.ConditionType.ProfileUnavailable; break;
    //                        }
    //                        break;
    //                    case "CONDITIONVALUE": condition.ConditionValue = xmlRead["value"]; break;
    //                }
    //            }
    //            xmlRead.Read();
    //        }
    //    }
    //    public static void WriteEventsToFile()
    //    {
    //        // open a connection to the Connections.profile file and load all the available ones to memory
    //        try
    //        {
    //            WriteEventsToFile(AppPath.EventsFilePath, new List<ReminderEvent>(Events.Values));
    //        }
    //        catch (Exception ex) 
    //        {
    //            string logMsg = "Error occurred while writing events to file";
    //            TrackingHelper.TrackError(TrackingHelper.RecordType.Both, "Error Occurred", logMsg, logMsg, ex);
    //        }
    //    }
    //    public static void WriteEventsToFile(string fileLocation)
    //    {
    //        try
    //        {
    //            WriteEventsToFile(fileLocation, new List<ReminderEvent>(Events.Values));
    //        }
    //        catch (Exception ex) 
    //        {
    //            string logMsg = "Error occurred while writing events to file";
    //            TrackingHelper.TrackError(TrackingHelper.RecordType.Both, "Error Occurred", logMsg, logMsg, ex);
    //        }
    //    }
    //    public static void WriteEventsToFile(string fileLocation, List<ReminderEvent> events)
    //    {
    //        try
    //        {
    //            lock (EventLocker)
    //            {
    //                XmlTextWriter xmlWrite = new XmlTextWriter(fileLocation, null);
    //                xmlWrite.WriteStartDocument();
    //                xmlWrite.WriteStartElement("Events");
    //                foreach (ReminderEvent rEvent in events)
    //                {
    //                    xmlWrite.WriteStartElement("Event");
    //                    xmlWrite.WriteAttributeString("guid", rEvent.EventGUID);

    //                    xmlWrite.WriteStartElement("EventName");
    //                    xmlWrite.WriteAttributeString("value", rEvent.Name);
    //                    xmlWrite.WriteEndElement();

    //                    xmlWrite.WriteStartElement("Message");
    //                    xmlWrite.WriteAttributeString("value", rEvent.Message);
    //                    xmlWrite.WriteEndElement();

    //                    xmlWrite.WriteStartElement("Enabled");
    //                    xmlWrite.WriteAttributeString("value", rEvent.Enabled.ToString());
    //                    xmlWrite.WriteEndElement();

    //                    xmlWrite.WriteStartElement("MaxOccurencesPerHour");
    //                    xmlWrite.WriteAttributeString("value", rEvent.MaxOccurencesPerHour.ToString());
    //                    xmlWrite.WriteEndElement();

    //                    xmlWrite.WriteStartElement("Conditions");
    //                    foreach (EventCondition condition in rEvent.Conditions)
    //                    {
    //                        xmlWrite.WriteStartElement("Condition");

    //                        xmlWrite.WriteStartElement("ConditionName");
    //                        xmlWrite.WriteAttributeString("value", condition.Name.ToString());
    //                        xmlWrite.WriteEndElement();

    //                        xmlWrite.WriteStartElement("Argument");
    //                        xmlWrite.WriteAttributeString("value", condition.Argument.ToString());
    //                        xmlWrite.WriteEndElement();

    //                        xmlWrite.WriteStartElement("ConditionType");
    //                        xmlWrite.WriteAttributeString("value", condition.Condition.ToString());
    //                        xmlWrite.WriteEndElement();

    //                        xmlWrite.WriteStartElement("ConditionValue");
    //                        xmlWrite.WriteAttributeString("value", condition.ConditionValue.ToString());
    //                        xmlWrite.WriteEndElement();

    //                        xmlWrite.WriteEndElement();
    //                    }
    //                    xmlWrite.WriteEndElement();
    //                    xmlWrite.WriteEndElement();
    //                }
    //                xmlWrite.WriteEndElement();
    //                xmlWrite.Flush();
    //                xmlWrite.Close();
    //            }
    //        }
    //        catch (Exception ex) 
    //        {
    //            string logMsg = "Error occurred while writing events to file";
    //            TrackingHelper.TrackError(TrackingHelper.RecordType.Both, "Error Occurred", logMsg, logMsg, ex);
    //        }
    //    }
    //    public static void FireEvent(string id)
    //    {

    //    }
    //    public static ReminderEvent GetEvent(string id)
    //    {
    //        ReminderEvent rEvent = null;
    //        lock (EventLocker)
    //        {
    //            Events.TryGetValue(id, out rEvent);
    //        }
    //        return rEvent;
    //    }
    //    public static void SaveEvent(ReminderEvent rEvent, bool writeToFile)
    //    {
    //        lock (EventLocker)
    //        {
    //            Events[rEvent.EventGUID] = rEvent;
    //            if (writeToFile)
    //                WriteEventsToFile();
    //        }
    //    }
    //    public static void DeleteEvent(string id)
    //    {
    //        lock (EventLocker)
    //        {
    //            ReminderEvent rEvent = null;
    //            if (Events.TryGetValue(id, out rEvent) && rEvent != null)
    //                Events.Remove(id);
    //        }
    //    }
    //}
}