﻿using System;
using System.Collections.Generic;
using System.Text;

namespace SmarterNotify.Connector
{
    public interface INotifyPluginProvider
    {   
        event NotifyHelper.AddNotificationDel AddNotification;

        void StartConnection();
        void StopConnection();
        bool IsPluginAvailable();
    }
    public class NotifyHelper
    {
        public delegate void AddNotificationDel(object sender, NotificationEventArgs e);
    }
    public class NotificationEventArgs
    {
        public ReminderValue Notification { get; set; }
    }
}
