﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using SmarterNotify.Data;
using SmarterNotify.DataHandlers;

namespace SmarterNotify.Threads
{
    public class AutoConnectorThread
    {
        public static void StartAutoConnectorThread()
        {
            Thread thdAuto = new Thread(new ThreadStart(AutoConnectorMethod));
            thdAuto.IsBackground = true;
            thdAuto.Name = "AutoConnectorBGThread";
            thdAuto.Start();
        }
        public static void AutoConnectorMethod()
        {
            foreach (ConnectionProfile profile in ConnectionProfileHandler.GetAllProfiles())
            {
                if (profile.ConnectionStatus == ConnectionProfile.ConnectionStatusType.Paused && !profile.IsPendingConnection)
                {
                    profile.IsPendingConnection = true;
                    profile.StartConnections(true);
                }
            }
        }
    }
}